.onLoad <- function(libname, pkgname)
{

}



vtk.Events <- c("NoEvent", 	
"AnyEvent", 	
"DeleteEvent", 	
"StartEvent", 	
"EndEvent", 	
"ProgressEvent", 	
"PickEvent", 	
"StartPickEvent", 	
"EndPickEvent", 	
"AbortCheckEvent", 	
"ExitEvent" ,	
"LeftButtonPressEvent", 	
"LeftButtonReleaseEvent", 	
"MiddleButtonPressEvent" ,	
"MiddleButtonReleaseEvent", 	
"RightButtonPressEvent",
"RightButtonReleaseEvent" ,	
"EnterEvent" ,	
"LeaveEvent" ,	
"KeyPressEvent", 	
"KeyReleaseEvent", 	
"CharEvent" ,	
"ExposeEvent", 	
"ConfigureEvent", 	
"TimerEvent",	
"MouseMoveEvent", 	
"ResetCameraEvent", 	
"ResetCameraClippingRangeEvent", 	
"ModifiedEvent",	
"WindowLevelEvent", 	
"StartWindowLevelEvent", 	
"EndWindowLevelEvent",	
"ResetWindowLevelEvent", 	
"NextDataEvent", 	
"PushDataStartEvent", 	
"SetOutputEvent",	
"EndOfDataEvent",	
"ErrorEvent",	
"WarningEvent", 	
"StartInteractionEvent", 	
"InteractionEvent",	
"EndInteractionEvent", 	
"EnableEvent",	
"DisableEvent",	
"CreateTimerEven", 	
"DestroyTimerEvent", 	
"PlaceWidgetEvent",	
"CursorChangedEvent", 	
"ExecuteInformationEvent", 	
"RenderWindowMessageEvent", 	
"UserEvent")

.On.ObjectDelete<-function(...){
     print("Cleared by VTK!")
#  print(.me)

#     attributes(.me)<-list(class="environment",INVALID=TRUE)
#     rm(list=ls(.me,all=T),envir=.me)
  }


InstallNotificator <- function(.env){
  if (!is.null(.env$obj)){
#    print("Install Notificator for:")
#    print.AsIs(.env$obj)
#    .Call("R_vtkObject_AddObserver_v1",.env$obj,"DeleteEvent",quote(.On.ObjectDelete()),.env,p=0.0,PACKAGE="RVTK.Base")
  }
}

wrapenv <- function(obj){
  env<-new.env(parent=.GlobalEnv)
  env$obj<-obj
#  InstallNotificator(env)
  return(env)
}

wrapvtkclass <- function(res,class){
  env<-new.env(parent=.GlobalEnv)
  env$obj <- res
  e <- eval(parse(text=paste(class,"(env)",sep="")))
  e$.me<-e
#  InstallNotificator(e)
  return(e)
}

dim.cast <- function(x,z){
  length(x) <- prod(z)
  dim(x) <- z
  return(x)
}


check.VTK <- function(.inst,.class){
  if(.class%in%class(.inst)){
     invisible(TRUE)
  } else {
    stop("Wrong VTK class!")
  }
}

vtkObjectBase <- function(.me=environment()){
  .me$GetClassName <- function(){
    .Call("R_vtkObjectBase_GetClassName",.me$obj,PACKAGE="RVTK.Base")
  }
  .me$IsTypeOf <- function(name){
    .Call("R_vtkObjectBase_IsTypeOf",.me$obj,name,PACKAGE="RVTK.Base")
  }
  .me$IsA <- function(name){
    .Call("R_vtkObjectBase_IsA",.me$obj,name,PACKAGE="RVTK.Base")
  }
  .me$Delete <- function(...){
#    	print.AsIs(.me$obj)
#	print("object deleted")
#        .me$InvokeEvent_v1("DeleteEvent")
#        .me$RemoveObservers_v1("DeleteEvent")
       .Call("R_vtkObjectBase_Delete",.me$obj,PACKAGE="RVTK.Base")
  }
  .me$Register <- function(){
    .Call("R_vtkObjectBase_Register",.me$obj,PACKAGE="RVTK.Base")
  }
  .me$UnRegister <- function(...){
     print.AsIs(.me$obj)
     print("object unregistered")
    .Call("R_vtkObjectBase_UnRegister",.me$obj,PACKAGE="RVTK.Base")
  }
  .me$GetReferenceCount <- function(){
    .Call("R_vtkObjectBase_GetReferenceCount",.me$obj,PACKAGE="RVTK.Base")
  }
  .me$SetReferenceCount <- function(count){
    .Call("R_vtkObjectBase_SetReferenceCount",.me$obj,count,PACKAGE="RVTK.Base")
  }
  if (identical(.me,environment())){
    .me$obj <- .Call("R_vtkObjectBase_New",PACKAGE="RVTK.Base")
  }
  class(.me) <- c("vtkObjectBase")
  return(.me)
}


vtkObject <- function(.me=environment()){
  .me <- vtkObjectBase(.me)

  .me$GetClassName <- function(){
    res<-.Call("R_vtkObject_GetClassName",.me$obj)
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkObject_IsTypeOf",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkObject_IsA",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkObject_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkObject(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkObject_NewInstance",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkObject(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DebugOn <- function(){
    res<-.Call("R_vtkObject_DebugOn",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DebugOff <- function(){
    res<-.Call("R_vtkObject_DebugOff",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetDebug <- function(){
    res<-.Call("R_vtkObject_GetDebug",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetDebug <- function( .debugFlag){
    .debugFlag<-(dim.cast(.debugFlag,c(1)))
    res<-.Call("R_vtkObject_SetDebug",.me$obj, .debugFlag,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$BreakOnError <- function(){
    res<-.Call("R_vtkObject_BreakOnError",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Modified <- function(){
    res<-.Call("R_vtkObject_Modified",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetMTime <- function(){
    res<-.Call("R_vtkObject_GetMTime",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetGlobalWarningDisplay <- function( .val){
    .val<-as.integer(dim.cast(.val,c(1)))
    res<-.Call("R_vtkObject_SetGlobalWarningDisplay",.me$obj, .val,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GlobalWarningDisplayOn <- function(){
    res<-.Call("R_vtkObject_GlobalWarningDisplayOn",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GlobalWarningDisplayOff <- function(){
    res<-.Call("R_vtkObject_GlobalWarningDisplayOff",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetGlobalWarningDisplay <- function(){
    res<-.Call("R_vtkObject_GetGlobalWarningDisplay",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }


  .me$Register <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkObject_Register",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$UnRegister <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkObject_UnRegister",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddObserver <- function( .event, .cmd, .p=0, ...){
    if("function"%in%class(.cmd)){
    .p<-as.single(dim.cast(.p,c(1)))
    res<-.Call("R_vtkObject_AddObserver",.me$obj, .event, quote(.cmd(...)), environment(), .p,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
    }
    return(NULL)
  }
 
  .me$AddObserver_v1 <- function( .event, .cmd, .p=0, ...){
    if("function"%in%class(.cmd)){
    res<-.Call("R_vtkObject_AddObserver_v1",.me$obj, .event, quote(.cmd(...)), environment(), .p,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
    }
    return(NULL)
  }
 
 
 
  .me$RemoveObserver <- function( .tag){
    res<-.Call("R_vtkObject_RemoveObserver",.me$obj, .tag,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$RemoveObservers <- function( .event){
   res<-.Call("R_vtkObject_RemoveObservers",.me$obj, .event,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$RemoveObservers_v1 <- function( .event){
    res<-.Call("R_vtkObject_RemoveObservers_v1",.me$obj, .event,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$HasObserver <- function( .event){
    res<-.Call("R_vtkObject_HasObserver",.me$obj, .event,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$HasObserver_v1 <- function( .event){
    res<-.Call("R_vtkObject_HasObserver_v1",.me$obj, .event,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
 
  .me$InvokeEvent <- function( .event){
    res<-.Call("R_vtkObject_InvokeEvent",.me$obj, .event,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InvokeEvent_v1 <- function( .event){
    res<-.Call("R_vtkObject_InvokeEvent_v1",.me$obj, .event,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  if (identical(.me,environment())){
    .me$obj <- .Call("R_vtkObject_New",PACKAGE="RVTK.Base")
  }
  
  class(.me) <- c("vtkObject",class(.me))
  return(.me)
}


