vtkCellTypes <- function(.me=environment()){
  .me <- vtkObject(.me)
  .me$GetClassName <- function(){
    res<-.Call("R_vtkCellTypes_GetClassName",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkCellTypes_IsTypeOf",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkCellTypes_IsA",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkCellTypes_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCellTypes(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkCellTypes_NewInstance",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCellTypes(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Allocate <- function( .sz, .ext){
    res<-.Call("R_vtkCellTypes_Allocate",.me$obj, .sz, .ext,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InsertCell <- function( .cellId, .type, .loc){
    res<-.Call("R_vtkCellTypes_InsertCell",.me$obj, .cellId, .type, .loc,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InsertNextCell <- function( .type, .loc){
    res<-.Call("R_vtkCellTypes_InsertNextCell",.me$obj, .type, .loc,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetCellTypes <- function( .ncells, .cellTypes=vtkUnsignedCharArray(), .cellLocations=vtkIntArray()){
    check.VTK(.cellTypes,"vtkUnsignedCharArray")
    check.VTK(.cellLocations,"vtkIntArray")
    res<-.Call("R_vtkCellTypes_SetCellTypes",.me$obj, .ncells, .cellTypes$obj, .cellLocations$obj,PACKAGE="RVTK.Base")
    res$.cellTypes <- vtkUnsignedCharArray(wrapenv(res$.cellTypes))
    res$.cellLocations <- vtkIntArray(wrapenv(res$.cellLocations))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellLocation <- function( .cellId){
    res<-.Call("R_vtkCellTypes_GetCellLocation",.me$obj, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DeleteCell <- function( .cellId){
    res<-.Call("R_vtkCellTypes_DeleteCell",.me$obj, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfTypes <- function(){
    res<-.Call("R_vtkCellTypes_GetNumberOfTypes",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsType <- function( .type){
    res<-.Call("R_vtkCellTypes_IsType",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InsertNextType <- function( .type){
    res<-.Call("R_vtkCellTypes_InsertNextType",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellType <- function( .cellId){
    res<-.Call("R_vtkCellTypes_GetCellType",.me$obj, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Squeeze <- function(){
    res<-.Call("R_vtkCellTypes_Squeeze",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Reset <- function(){
    res<-.Call("R_vtkCellTypes_Reset",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetActualMemorySize <- function(){
    res<-.Call("R_vtkCellTypes_GetActualMemorySize",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DeepCopy <- function( .src=vtkCellTypes()){
    check.VTK(.src,"vtkCellTypes")
    res<-.Call("R_vtkCellTypes_DeepCopy",.me$obj, .src$obj,PACKAGE="RVTK.Base")
    res$.src <- vtkCellTypes(wrapenv(res$.src))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  if (identical(.me,environment())){
   .me$obj <- .Call("R_vtkCellTypes_New")
    reg.finalizer(.me, .me$Delete)
  }
  class(.me) <- c("vtkCellTypes",class(.me))
  return(.me)
}
