vtkDataSet <- function(.me=environment()){
  .me <- vtkDataObject(.me)
  .me$GetClassName <- function(){
    res<-.Call("R_vtkDataSet_GetClassName",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkDataSet_IsTypeOf",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkDataSet_IsA",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkDataSet_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkDataSet(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkDataSet_NewInstance",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkDataSet(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$CopyStructure <- function( .ds=vtkDataSet()){
    check.VTK(.ds,"vtkDataSet")
    res<-.Call("R_vtkDataSet_CopyStructure",.me$obj, .ds$obj,PACKAGE="RVTK.Base")
    res$.ds <- vtkDataSet(wrapenv(res$.ds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfPoints <- function(){
    res<-.Call("R_vtkDataSet_GetNumberOfPoints",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfCells <- function(){
    res<-.Call("R_vtkDataSet_GetNumberOfCells",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetPoint <- function( .ptId){
    res<-.Call("R_vtkDataSet_GetPoint",.me$obj, .ptId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetPoint_v1 <- function( .id, .x=as.double(rep.int(1,3))){
    res<-.Call("R_vtkDataSet_GetPoint_v1",.me$obj, .id, .x,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCell <- function( .cellId){
    res<-.Call("R_vtkDataSet_GetCell",.me$obj, .cellId,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCell(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCell_v1 <- function( .cellId, .cell=vtkGenericCell()){
    check.VTK(.cell,"vtkGenericCell")
    res<-.Call("R_vtkDataSet_GetCell_v1",.me$obj, .cellId, .cell$obj,PACKAGE="RVTK.Base")
    res$.cell <- vtkGenericCell(wrapenv(res$.cell))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellBounds <- function( .cellId, .bounds=as.double(rep.int(1,6))){
    res<-.Call("R_vtkDataSet_GetCellBounds",.me$obj, .cellId, .bounds,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellType <- function( .cellId){
    res<-.Call("R_vtkDataSet_GetCellType",.me$obj, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellTypes <- function( .types=vtkCellTypes()){
    check.VTK(.types,"vtkCellTypes")
    res<-.Call("R_vtkDataSet_GetCellTypes",.me$obj, .types$obj,PACKAGE="RVTK.Base")
    res$.types <- vtkCellTypes(wrapenv(res$.types))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellPoints <- function( .cellId, .ptIds=vtkIdList()){
    check.VTK(.ptIds,"vtkIdList")
    res<-.Call("R_vtkDataSet_GetCellPoints",.me$obj, .cellId, .ptIds$obj,PACKAGE="RVTK.Base")
    res$.ptIds <- vtkIdList(wrapenv(res$.ptIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetPointCells <- function( .ptId, .cellIds=vtkIdList()){
    check.VTK(.cellIds,"vtkIdList")
    res<-.Call("R_vtkDataSet_GetPointCells",.me$obj, .ptId, .cellIds$obj,PACKAGE="RVTK.Base")
    res$.cellIds <- vtkIdList(wrapenv(res$.cellIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellNeighbors <- function( .cellId, .ptIds=vtkIdList(), .cellIds=vtkIdList()){
    check.VTK(.ptIds,"vtkIdList")
    check.VTK(.cellIds,"vtkIdList")
    res<-.Call("R_vtkDataSet_GetCellNeighbors",.me$obj, .cellId, .ptIds$obj, .cellIds$obj,PACKAGE="RVTK.Base")
    res$.ptIds <- vtkIdList(wrapenv(res$.ptIds))
    res$.cellIds <- vtkIdList(wrapenv(res$.cellIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$FindPoint <- function( .x, .y, .z){
    res<-.Call("R_vtkDataSet_FindPoint",.me$obj, .x, .y, .z,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$FindPoint_v1 <- function( .x=as.double(rep.int(1,3))){
    res<-.Call("R_vtkDataSet_FindPoint_v1",.me$obj, .x,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$FindCell <- function( .x=as.double(rep.int(1,3)), .cell=vtkCell(), .cellId, .tol2, .subId=as.integer(rep.int(1,1)), .pcoords=as.double(rep.int(1,3)), .weights){
    check.VTK(.cell,"vtkCell")
    res<-.Call("R_vtkDataSet_FindCell",.me$obj, .x, .cell$obj, .cellId, .tol2, .subId, .pcoords, .weights,PACKAGE="RVTK.Base")
    res$.cell <- vtkCell(wrapenv(res$.cell))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$FindCell_v1 <- function( .x=as.double(rep.int(1,3)), .cell=vtkCell(), .gencell=vtkGenericCell(), .cellId, .tol2, .subId=as.integer(rep.int(1,1)), .pcoords=as.double(rep.int(1,3)), .weights){
    check.VTK(.cell,"vtkCell")
    check.VTK(.gencell,"vtkGenericCell")
    res<-.Call("R_vtkDataSet_FindCell_v1",.me$obj, .x, .cell$obj, .gencell$obj, .cellId, .tol2, .subId, .pcoords, .weights,PACKAGE="RVTK.Base")
    res$.cell <- vtkCell(wrapenv(res$.cell))
    res$.gencell <- vtkGenericCell(wrapenv(res$.gencell))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$FindAndGetCell <- function( .x=as.double(rep.int(1,3)), .cell=vtkCell(), .cellId, .tol2, .subId=as.integer(rep.int(1,1)), .pcoords=as.double(rep.int(1,3)), .weights){
    check.VTK(.cell,"vtkCell")
    res<-.Call("R_vtkDataSet_FindAndGetCell",.me$obj, .x, .cell$obj, .cellId, .tol2, .subId, .pcoords, .weights,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCell(wrapenv(res$ret.val))
    res$.cell <- vtkCell(wrapenv(res$.cell))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetMTime <- function(){
    res<-.Call("R_vtkDataSet_GetMTime",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellData <- function(){
    res<-.Call("R_vtkDataSet_GetCellData",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCellData(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetPointData <- function(){
    res<-.Call("R_vtkDataSet_GetPointData",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkPointData(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Squeeze <- function(){
    res<-.Call("R_vtkDataSet_Squeeze",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ComputeBounds <- function(){
    res<-.Call("R_vtkDataSet_ComputeBounds",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetBounds <- function(){
    res<-.Call("R_vtkDataSet_GetBounds",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetBounds_v1 <- function( .bounds=as.double(rep.int(1,6))){
    res<-.Call("R_vtkDataSet_GetBounds_v1",.me$obj, .bounds,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCenter <- function(){
    res<-.Call("R_vtkDataSet_GetCenter",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCenter_v1 <- function( .center=as.double(rep.int(1,3))){
    res<-.Call("R_vtkDataSet_GetCenter_v1",.me$obj, .center,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetLength <- function(){
    res<-.Call("R_vtkDataSet_GetLength",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Initialize <- function(){
    res<-.Call("R_vtkDataSet_Initialize",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetScalarRange <- function( .range=as.double(rep.int(1,2))){
    res<-.Call("R_vtkDataSet_GetScalarRange",.me$obj, .range,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetScalarRange_v1 <- function(){
    res<-.Call("R_vtkDataSet_GetScalarRange_v1",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetMaxCellSize <- function(){
    res<-.Call("R_vtkDataSet_GetMaxCellSize",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetActualMemorySize <- function(){
    res<-.Call("R_vtkDataSet_GetActualMemorySize",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetDataObjectType <- function(){
    res<-.Call("R_vtkDataSet_GetDataObjectType",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ShallowCopy <- function( .dataObject=vtkDataObject()){
    check.VTK(.dataObject,"vtkDataObject")
    res<-.Call("R_vtkDataSet_ShallowCopy",.me$obj, .dataObject$obj,PACKAGE="RVTK.Base")
    res$.dataObject <- vtkDataObject(wrapenv(res$.dataObject))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DeepCopy <- function( .dataObject=vtkDataObject()){
    check.VTK(.dataObject,"vtkDataObject")
    res<-.Call("R_vtkDataSet_DeepCopy",.me$obj, .dataObject$obj,PACKAGE="RVTK.Base")
    res$.dataObject <- vtkDataObject(wrapenv(res$.dataObject))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$CheckAttributes <- function(){
    res<-.Call("R_vtkDataSet_CheckAttributes",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  class(.me) <- c("vtkDataSet",class(.me))
  return(.me)
}
