vtkHull <- function(.me=environment()){
  .me <- vtkPolyDataToPolyDataFilter(.me)
  .me$GetClassName <- function(){
    res<-.Call("R_vtkHull_GetClassName",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkHull_IsTypeOf",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkHull_IsA",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkHull_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkHull(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkHull_NewInstance",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkHull(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$RemoveAllPlanes <- function(){
    res<-.Call("R_vtkHull_RemoveAllPlanes",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddPlane <- function( .A, .B, .C){
    res<-.Call("R_vtkHull_AddPlane",.me$obj, .A, .B, .C,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddPlane_v1 <- function( .plane=as.double(rep.int(1,3))){
    res<-.Call("R_vtkHull_AddPlane_v1",.me$obj, .plane,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetPlane <- function( .i, .A, .B, .C){
    res<-.Call("R_vtkHull_SetPlane",.me$obj, .i, .A, .B, .C,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetPlane_v1 <- function( .i, .plane=as.double(rep.int(1,3))){
    res<-.Call("R_vtkHull_SetPlane_v1",.me$obj, .i, .plane,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddPlane_v2 <- function( .A, .B, .C, .D){
    res<-.Call("R_vtkHull_AddPlane_v2",.me$obj, .A, .B, .C, .D,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddPlane_v3 <- function( .plane=as.double(rep.int(1,3)), .D){
    res<-.Call("R_vtkHull_AddPlane_v3",.me$obj, .plane, .D,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetPlane_v2 <- function( .i, .A, .B, .C, .D){
    res<-.Call("R_vtkHull_SetPlane_v2",.me$obj, .i, .A, .B, .C, .D,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetPlane_v3 <- function( .i, .plane=as.double(rep.int(1,3)), .D){
    res<-.Call("R_vtkHull_SetPlane_v3",.me$obj, .i, .plane, .D,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetPlanes <- function( .planes=vtkPlanes()){
    check.VTK(.planes,"vtkPlanes")
    res<-.Call("R_vtkHull_SetPlanes",.me$obj, .planes$obj,PACKAGE="RVTK.Base")
    res$.planes <- vtkPlanes(wrapenv(res$.planes))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfPlanes <- function(){
    res<-.Call("R_vtkHull_GetNumberOfPlanes",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddCubeVertexPlanes <- function(){
    res<-.Call("R_vtkHull_AddCubeVertexPlanes",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddCubeEdgePlanes <- function(){
    res<-.Call("R_vtkHull_AddCubeEdgePlanes",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddCubeFacePlanes <- function(){
    res<-.Call("R_vtkHull_AddCubeFacePlanes",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddRecursiveSpherePlanes <- function( .level){
    res<-.Call("R_vtkHull_AddRecursiveSpherePlanes",.me$obj, .level,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GenerateHull <- function( .pd=vtkPolyData(), .bounds){
    check.VTK(.pd,"vtkPolyData")
    res<-.Call("R_vtkHull_GenerateHull",.me$obj, .pd$obj, .bounds,PACKAGE="RVTK.Base")
    res$.pd <- vtkPolyData(wrapenv(res$.pd))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GenerateHull_v1 <- function( .pd=vtkPolyData(), .xmin, .xmax, .ymin, .ymax, .zmin, .zmax){
    check.VTK(.pd,"vtkPolyData")
    res<-.Call("R_vtkHull_GenerateHull_v1",.me$obj, .pd$obj, .xmin, .xmax, .ymin, .ymax, .zmin, .zmax,PACKAGE="RVTK.Base")
    res$.pd <- vtkPolyData(wrapenv(res$.pd))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  if (identical(.me,environment())){
   .me$obj <- .Call("R_vtkHull_New")
    reg.finalizer(.me, .me$Delete)
  }
  class(.me) <- c("vtkHull",class(.me))
  return(.me)
}
