vtkObjectFactory <- function(.me=environment()){
  .me <- vtkObject(.me)
  .me$CreateInstance <- function( .vtkclassname){
    res<-.Call("R_vtkObjectFactory_CreateInstance",.me$obj, .vtkclassname,PACKAGE="RVTK.Base")
    res$ret.val <- vtkObject(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$CreateAllInstance <- function( .vtkclassname, .retList=vtkCollection()){
    check.VTK(.retList,"vtkCollection")
    res<-.Call("R_vtkObjectFactory_CreateAllInstance",.me$obj, .vtkclassname, .retList$obj,PACKAGE="RVTK.Base")
    res$.retList <- vtkCollection(wrapenv(res$.retList))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ReHash <- function(){
    res<-.Call("R_vtkObjectFactory_ReHash",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$RegisterFactory <- function( .factory=vtkObjectFactory()){
    check.VTK(.factory,"vtkObjectFactory")
    res<-.Call("R_vtkObjectFactory_RegisterFactory",.me$obj, .factory$obj,PACKAGE="RVTK.Base")
    res$.factory <- vtkObjectFactory(wrapenv(res$.factory))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$UnRegisterFactory <- function( .factory=vtkObjectFactory()){
    check.VTK(.factory,"vtkObjectFactory")
    res<-.Call("R_vtkObjectFactory_UnRegisterFactory",.me$obj, .factory$obj,PACKAGE="RVTK.Base")
    res$.factory <- vtkObjectFactory(wrapenv(res$.factory))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$UnRegisterAllFactories <- function(){
    res<-.Call("R_vtkObjectFactory_UnRegisterAllFactories",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetRegisteredFactories <- function(){
    res<-.Call("R_vtkObjectFactory_GetRegisteredFactories",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkObjectFactoryCollection(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$HasOverrideAny <- function( .className){
    res<-.Call("R_vtkObjectFactory_HasOverrideAny",.me$obj, .className,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetOverrideInformation <- function( .name, .ret=vtkOverrideInformationCollection()){
    check.VTK(.ret,"vtkOverrideInformationCollection")
    res<-.Call("R_vtkObjectFactory_GetOverrideInformation",.me$obj, .name, .ret$obj,PACKAGE="RVTK.Base")
    res$.ret <- vtkOverrideInformationCollection(wrapenv(res$.ret))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetAllEnableFlags <- function( .flag, .className){
    res<-.Call("R_vtkObjectFactory_SetAllEnableFlags",.me$obj, .flag, .className,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetAllEnableFlags_v1 <- function( .flag, .className, .subclassName){
    res<-.Call("R_vtkObjectFactory_SetAllEnableFlags_v1",.me$obj, .flag, .className, .subclassName,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetClassName <- function(){
    res<-.Call("R_vtkObjectFactory_GetClassName",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkObjectFactory_IsTypeOf",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkObjectFactory_IsA",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkObjectFactory_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkObjectFactory(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkObjectFactory_NewInstance",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkObjectFactory(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetVTKSourceVersion <- function(){
    res<-.Call("R_vtkObjectFactory_GetVTKSourceVersion",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetDescription <- function(){
    res<-.Call("R_vtkObjectFactory_GetDescription",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfOverrides <- function(){
    res<-.Call("R_vtkObjectFactory_GetNumberOfOverrides",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetClassOverrideName <- function( .index){
    res<-.Call("R_vtkObjectFactory_GetClassOverrideName",.me$obj, .index,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetClassOverrideWithName <- function( .index){
    res<-.Call("R_vtkObjectFactory_GetClassOverrideWithName",.me$obj, .index,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetEnableFlag <- function( .index){
    res<-.Call("R_vtkObjectFactory_GetEnableFlag",.me$obj, .index,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetOverrideDescription <- function( .index){
    res<-.Call("R_vtkObjectFactory_GetOverrideDescription",.me$obj, .index,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetEnableFlag <- function( .flag, .className, .subclassName){
    res<-.Call("R_vtkObjectFactory_SetEnableFlag",.me$obj, .flag, .className, .subclassName,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetEnableFlag_v1 <- function( .className, .subclassName){
    res<-.Call("R_vtkObjectFactory_GetEnableFlag_v1",.me$obj, .className, .subclassName,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$HasOverride <- function( .className){
    res<-.Call("R_vtkObjectFactory_HasOverride",.me$obj, .className,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$HasOverride_v1 <- function( .className, .subclassName){
    res<-.Call("R_vtkObjectFactory_HasOverride_v1",.me$obj, .className, .subclassName,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Disable <- function( .className){
    res<-.Call("R_vtkObjectFactory_Disable",.me$obj, .className,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetLibraryPath <- function(){
    res<-.Call("R_vtkObjectFactory_GetLibraryPath",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  class(.me) <- c("vtkObjectFactory",class(.me))
  return(.me)
}
