vtkPolyData <- function(.me=environment()){
  .me <- vtkPointSet(.me)
  .me$GetClassName <- function(){
    res<-.Call("R_vtkPolyData_GetClassName",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkPolyData_IsTypeOf",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkPolyData_IsA",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkPolyData_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkPolyData(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkPolyData_NewInstance",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkPolyData(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetDataObjectType <- function(){
    res<-.Call("R_vtkPolyData_GetDataObjectType",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$CopyStructure <- function( .ds=vtkDataSet()){
    check.VTK(.ds,"vtkDataSet")
    res<-.Call("R_vtkPolyData_CopyStructure",.me$obj, .ds$obj,PACKAGE="RVTK.Base")
    res$.ds <- vtkDataSet(wrapenv(res$.ds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfCells <- function(){
    res<-.Call("R_vtkPolyData_GetNumberOfCells",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCell <- function( .cellId){
    res<-.Call("R_vtkPolyData_GetCell",.me$obj, .cellId,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCell(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCell_v1 <- function( .cellId, .cell=vtkGenericCell()){
    check.VTK(.cell,"vtkGenericCell")
    res<-.Call("R_vtkPolyData_GetCell_v1",.me$obj, .cellId, .cell$obj,PACKAGE="RVTK.Base")
    res$.cell <- vtkGenericCell(wrapenv(res$.cell))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellType <- function( .cellId){
    res<-.Call("R_vtkPolyData_GetCellType",.me$obj, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellBounds <- function( .cellId, .bounds=as.double(rep.int(1,6))){
    res<-.Call("R_vtkPolyData_GetCellBounds",.me$obj, .cellId, .bounds,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellNeighbors <- function( .cellId, .ptIds=vtkIdList(), .cellIds=vtkIdList()){
    check.VTK(.ptIds,"vtkIdList")
    check.VTK(.cellIds,"vtkIdList")
    res<-.Call("R_vtkPolyData_GetCellNeighbors",.me$obj, .cellId, .ptIds$obj, .cellIds$obj,PACKAGE="RVTK.Base")
    res$.ptIds <- vtkIdList(wrapenv(res$.ptIds))
    res$.cellIds <- vtkIdList(wrapenv(res$.cellIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$CopyCells <- function( .pd=vtkPolyData(), .idList=vtkIdList(), .locator=vtkPointLocator()){
    check.VTK(.pd,"vtkPolyData")
    check.VTK(.idList,"vtkIdList")
    check.VTK(.locator,"vtkPointLocator")
    res<-.Call("R_vtkPolyData_CopyCells",.me$obj, .pd$obj, .idList$obj, .locator$obj,PACKAGE="RVTK.Base")
    res$.pd <- vtkPolyData(wrapenv(res$.pd))
    res$.idList <- vtkIdList(wrapenv(res$.idList))
    res$.locator <- vtkPointLocator(wrapenv(res$.locator))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellPoints <- function( .cellId, .ptIds=vtkIdList()){
    check.VTK(.ptIds,"vtkIdList")
    res<-.Call("R_vtkPolyData_GetCellPoints",.me$obj, .cellId, .ptIds$obj,PACKAGE="RVTK.Base")
    res$.ptIds <- vtkIdList(wrapenv(res$.ptIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetPointCells <- function( .ptId, .cellIds=vtkIdList()){
    check.VTK(.cellIds,"vtkIdList")
    res<-.Call("R_vtkPolyData_GetPointCells",.me$obj, .ptId, .cellIds$obj,PACKAGE="RVTK.Base")
    res$.cellIds <- vtkIdList(wrapenv(res$.cellIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ComputeBounds <- function(){
    res<-.Call("R_vtkPolyData_ComputeBounds",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Squeeze <- function(){
    res<-.Call("R_vtkPolyData_Squeeze",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetMaxCellSize <- function(){
    res<-.Call("R_vtkPolyData_GetMaxCellSize",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetVerts <- function( .v=vtkCellArray()){
    check.VTK(.v,"vtkCellArray")
    res<-.Call("R_vtkPolyData_SetVerts",.me$obj, .v$obj,PACKAGE="RVTK.Base")
    res$.v <- vtkCellArray(wrapenv(res$.v))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetVerts <- function(){
    res<-.Call("R_vtkPolyData_GetVerts",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCellArray(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetLines <- function( .l=vtkCellArray()){
    check.VTK(.l,"vtkCellArray")
    res<-.Call("R_vtkPolyData_SetLines",.me$obj, .l$obj,PACKAGE="RVTK.Base")
    res$.l <- vtkCellArray(wrapenv(res$.l))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetLines <- function(){
    res<-.Call("R_vtkPolyData_GetLines",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCellArray(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetPolys <- function( .p=vtkCellArray()){
    check.VTK(.p,"vtkCellArray")
    res<-.Call("R_vtkPolyData_SetPolys",.me$obj, .p$obj,PACKAGE="RVTK.Base")
    res$.p <- vtkCellArray(wrapenv(res$.p))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetPolys <- function(){
    res<-.Call("R_vtkPolyData_GetPolys",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCellArray(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetStrips <- function( .s=vtkCellArray()){
    check.VTK(.s,"vtkCellArray")
    res<-.Call("R_vtkPolyData_SetStrips",.me$obj, .s$obj,PACKAGE="RVTK.Base")
    res$.s <- vtkCellArray(wrapenv(res$.s))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetStrips <- function(){
    res<-.Call("R_vtkPolyData_GetStrips",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkCellArray(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfVerts <- function(){
    res<-.Call("R_vtkPolyData_GetNumberOfVerts",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfLines <- function(){
    res<-.Call("R_vtkPolyData_GetNumberOfLines",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfPolys <- function(){
    res<-.Call("R_vtkPolyData_GetNumberOfPolys",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfStrips <- function(){
    res<-.Call("R_vtkPolyData_GetNumberOfStrips",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Allocate <- function( .numCells, .extSize){
    res<-.Call("R_vtkPolyData_Allocate",.me$obj, .numCells, .extSize,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Allocate_v1 <- function( .inPolyData=vtkPolyData(), .numCells, .extSize){
    check.VTK(.inPolyData,"vtkPolyData")
    res<-.Call("R_vtkPolyData_Allocate_v1",.me$obj, .inPolyData$obj, .numCells, .extSize,PACKAGE="RVTK.Base")
    res$.inPolyData <- vtkPolyData(wrapenv(res$.inPolyData))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InsertNextCell <- function( .type, .npts, .pts){
    res<-.Call("R_vtkPolyData_InsertNextCell",.me$obj, .type, .npts, .pts,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InsertNextCell_v1 <- function( .type, .pts=vtkIdList()){
    check.VTK(.pts,"vtkIdList")
    res<-.Call("R_vtkPolyData_InsertNextCell_v1",.me$obj, .type, .pts$obj,PACKAGE="RVTK.Base")
    res$.pts <- vtkIdList(wrapenv(res$.pts))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Reset <- function(){
    res<-.Call("R_vtkPolyData_Reset",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$BuildCells <- function(){
    res<-.Call("R_vtkPolyData_BuildCells",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$BuildLinks <- function( .initialSize){
    res<-.Call("R_vtkPolyData_BuildLinks",.me$obj, .initialSize,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DeleteCells <- function(){
    res<-.Call("R_vtkPolyData_DeleteCells",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DeleteLinks <- function(){
    res<-.Call("R_vtkPolyData_DeleteLinks",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetPointCells_v1 <- function( .ptId, .ncells=(rep.int(1,1)), .cells){
    res<-.Call("R_vtkPolyData_GetPointCells_v1",.me$obj, .ptId, .ncells, .cells,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellEdgeNeighbors <- function( .cellId, .p1, .p2, .cellIds=vtkIdList()){
    check.VTK(.cellIds,"vtkIdList")
    res<-.Call("R_vtkPolyData_GetCellEdgeNeighbors",.me$obj, .cellId, .p1, .p2, .cellIds$obj,PACKAGE="RVTK.Base")
    res$.cellIds <- vtkIdList(wrapenv(res$.cellIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellPoints_v1 <- function( .cellId, .npts=as.integer(rep.int(1,1)), .pts){
    res<-.Call("R_vtkPolyData_GetCellPoints_v1",.me$obj, .cellId, .npts, .pts,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsTriangle <- function( .v1, .v2, .v3){
    res<-.Call("R_vtkPolyData_IsTriangle",.me$obj, .v1, .v2, .v3,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsEdge <- function( .p1, .p2){
    res<-.Call("R_vtkPolyData_IsEdge",.me$obj, .p1, .p2,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsPointUsedByCell <- function( .ptId, .cellId){
    res<-.Call("R_vtkPolyData_IsPointUsedByCell",.me$obj, .ptId, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ReplaceCell <- function( .cellId, .npts, .pts){
    res<-.Call("R_vtkPolyData_ReplaceCell",.me$obj, .cellId, .npts, .pts,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ReplaceCellPoint <- function( .cellId, .oldPtId, .newPtId){
    res<-.Call("R_vtkPolyData_ReplaceCellPoint",.me$obj, .cellId, .oldPtId, .newPtId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ReverseCell <- function( .cellId){
    res<-.Call("R_vtkPolyData_ReverseCell",.me$obj, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DeletePoint <- function( .ptId){
    res<-.Call("R_vtkPolyData_DeletePoint",.me$obj, .ptId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DeleteCell <- function( .cellId){
    res<-.Call("R_vtkPolyData_DeleteCell",.me$obj, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InsertNextLinkedPoint <- function( .numLinks){
    res<-.Call("R_vtkPolyData_InsertNextLinkedPoint",.me$obj, .numLinks,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InsertNextLinkedPoint_v1 <- function( .x=as.double(rep.int(1,3)), .numLinks){
    res<-.Call("R_vtkPolyData_InsertNextLinkedPoint_v1",.me$obj, .x, .numLinks,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$InsertNextLinkedCell <- function( .type, .npts, .pts){
    res<-.Call("R_vtkPolyData_InsertNextLinkedCell",.me$obj, .type, .npts, .pts,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ReplaceLinkedCell <- function( .cellId, .npts, .pts){
    res<-.Call("R_vtkPolyData_ReplaceLinkedCell",.me$obj, .cellId, .npts, .pts,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$RemoveCellReference <- function( .cellId){
    res<-.Call("R_vtkPolyData_RemoveCellReference",.me$obj, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddCellReference <- function( .cellId){
    res<-.Call("R_vtkPolyData_AddCellReference",.me$obj, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$RemoveReferenceToCell <- function( .ptId, .cellId){
    res<-.Call("R_vtkPolyData_RemoveReferenceToCell",.me$obj, .ptId, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$AddReferenceToCell <- function( .ptId, .cellId){
    res<-.Call("R_vtkPolyData_AddReferenceToCell",.me$obj, .ptId, .cellId,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ResizeCellList <- function( .ptId, .size){
    res<-.Call("R_vtkPolyData_ResizeCellList",.me$obj, .ptId, .size,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$Initialize <- function(){
    res<-.Call("R_vtkPolyData_Initialize",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetUpdateExtent <- function( .piece, .numPieces, .ghostLevel){
    res<-.Call("R_vtkPolyData_SetUpdateExtent",.me$obj, .piece, .numPieces, .ghostLevel,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetUpdateExtent_v1 <- function( .piece, .numPieces){
    res<-.Call("R_vtkPolyData_SetUpdateExtent_v1",.me$obj, .piece, .numPieces,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetUpdateExtent <- function( .piece=as.integer(rep.int(1,1)), .numPieces=as.integer(rep.int(1,1)), .ghostLevel=as.integer(rep.int(1,1))){
    res<-.Call("R_vtkPolyData_GetUpdateExtent",.me$obj, .piece, .numPieces, .ghostLevel,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetUpdateExtent_v1 <- function(){
    res<-.Call("R_vtkPolyData_GetUpdateExtent_v1",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetUpdateExtent_v2 <- function( ._arg1=as.integer(rep.int(1,1)), ._arg2=as.integer(rep.int(1,1)), ._arg3=as.integer(rep.int(1,1)), ._arg4=as.integer(rep.int(1,1)), ._arg5=as.integer(rep.int(1,1)), ._arg6=as.integer(rep.int(1,1))){
    res<-.Call("R_vtkPolyData_GetUpdateExtent_v2",.me$obj, ._arg1, ._arg2, ._arg3, ._arg4, ._arg5, ._arg6,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetUpdateExtent_v3 <- function( ._arg){
    res<-.Call("R_vtkPolyData_GetUpdateExtent_v3",.me$obj, ._arg,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetUpdateExtent_v2 <- function( .x1, .x2, .y1, .y2, .z1, .z2){
    res<-.Call("R_vtkPolyData_SetUpdateExtent_v2",.me$obj, .x1, .x2, .y1, .y2, .z1, .z2,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetUpdateExtent_v3 <- function( .ext){
    res<-.Call("R_vtkPolyData_SetUpdateExtent_v3",.me$obj, .ext,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetPiece <- function(){
    res<-.Call("R_vtkPolyData_GetPiece",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetNumberOfPieces <- function(){
    res<-.Call("R_vtkPolyData_GetNumberOfPieces",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetGhostLevel <- function(){
    res<-.Call("R_vtkPolyData_GetGhostLevel",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetActualMemorySize <- function(){
    res<-.Call("R_vtkPolyData_GetActualMemorySize",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ShallowCopy <- function( .dataObject=vtkDataObject()){
    check.VTK(.dataObject,"vtkDataObject")
    res<-.Call("R_vtkPolyData_ShallowCopy",.me$obj, .dataObject$obj,PACKAGE="RVTK.Base")
    res$.dataObject <- vtkDataObject(wrapenv(res$.dataObject))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$DeepCopy <- function( .dataObject=vtkDataObject()){
    check.VTK(.dataObject,"vtkDataObject")
    res<-.Call("R_vtkPolyData_DeepCopy",.me$obj, .dataObject$obj,PACKAGE="RVTK.Base")
    res$.dataObject <- vtkDataObject(wrapenv(res$.dataObject))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$RemoveGhostCells <- function( .level){
    res<-.Call("R_vtkPolyData_RemoveGhostCells",.me$obj, .level,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  if (identical(.me,environment())){
   .me$obj <- .Call("R_vtkPolyData_New")
    reg.finalizer(.me, .me$Delete)
  }
  class(.me) <- c("vtkPolyData",class(.me))
  return(.me)
}
