vtkStructuredData <- function(.me=environment()){
  .me <- vtkObject(.me)
  .me$GetClassName <- function(){
    res<-.Call("R_vtkStructuredData_GetClassName",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkStructuredData_IsTypeOf",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkStructuredData_IsA",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkStructuredData_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkStructuredData(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkStructuredData_NewInstance",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkStructuredData(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetDimensions <- function( .inDim=as.integer(rep.int(1,3)), .dim=as.integer(rep.int(1,3))){
    res<-.Call("R_vtkStructuredData_SetDimensions",.me$obj, .inDim, .dim,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SetExtent <- function( .inExt=as.integer(rep.int(1,6)), .ext=as.integer(rep.int(1,6))){
    res<-.Call("R_vtkStructuredData_SetExtent",.me$obj, .inExt, .ext,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetDataDimension <- function( .dataDescription){
    res<-.Call("R_vtkStructuredData_GetDataDimension",.me$obj, .dataDescription,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellPoints <- function( .cellId, .ptIds=vtkIdList(), .dataDescription, .dim=as.integer(rep.int(1,3))){
    check.VTK(.ptIds,"vtkIdList")
    res<-.Call("R_vtkStructuredData_GetCellPoints",.me$obj, .cellId, .ptIds$obj, .dataDescription, .dim,PACKAGE="RVTK.Base")
    res$.ptIds <- vtkIdList(wrapenv(res$.ptIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetPointCells <- function( .ptId, .cellIds=vtkIdList(), .dim=as.integer(rep.int(1,3))){
    check.VTK(.cellIds,"vtkIdList")
    res<-.Call("R_vtkStructuredData_GetPointCells",.me$obj, .ptId, .cellIds$obj, .dim,PACKAGE="RVTK.Base")
    res$.cellIds <- vtkIdList(wrapenv(res$.cellIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$GetCellNeigbors <- function( .cellId, .ptIds=vtkIdList(), .cellIds=vtkIdList(), .dim=as.integer(rep.int(1,3))){
    check.VTK(.ptIds,"vtkIdList")
    check.VTK(.cellIds,"vtkIdList")
    res<-.Call("R_vtkStructuredData_GetCellNeigbors",.me$obj, .cellId, .ptIds$obj, .cellIds$obj, .dim,PACKAGE="RVTK.Base")
    res$.ptIds <- vtkIdList(wrapenv(res$.ptIds))
    res$.cellIds <- vtkIdList(wrapenv(res$.cellIds))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ComputePointId <- function( .dim=as.integer(rep.int(1,3)), .ijk=as.integer(rep.int(1,3))){
    res<-.Call("R_vtkStructuredData_ComputePointId",.me$obj, .dim, .ijk,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ComputeCellId <- function( .dim=as.integer(rep.int(1,3)), .ijk=as.integer(rep.int(1,3))){
    res<-.Call("R_vtkStructuredData_ComputeCellId",.me$obj, .dim, .ijk,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  class(.me) <- c("vtkStructuredData",class(.me))
  return(.me)
}
