vtkXMLUtilities <- function(.me=environment()){
  .me <- vtkObject(.me)
  .me$GetClassName <- function(){
    res<-.Call("R_vtkXMLUtilities_GetClassName",.me$obj,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsTypeOf <- function( .type){
    res<-.Call("R_vtkXMLUtilities_IsTypeOf",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$IsA <- function( .type){
    res<-.Call("R_vtkXMLUtilities_IsA",.me$obj, .type,PACKAGE="RVTK.Base")
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$SafeDownCast <- function( .o=vtkObjectBase()){
    check.VTK(.o,"vtkObjectBase")
    res<-.Call("R_vtkXMLUtilities_SafeDownCast",.me$obj, .o$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkXMLUtilities(wrapenv(res$ret.val))
    res$.o <- vtkObjectBase(wrapenv(res$.o))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$NewInstance <- function(){
    res<-.Call("R_vtkXMLUtilities_NewInstance",.me$obj,PACKAGE="RVTK.Base")
    res$ret.val <- vtkXMLUtilities(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$WriteElementToFile <- function( .elem=vtkXMLDataElement(), .filename, .indent=vtkIndent()){
    check.VTK(.elem,"vtkXMLDataElement")
    check.VTK(.indent,"vtkIndent")
    res<-.Call("R_vtkXMLUtilities_WriteElementToFile",.me$obj, .elem$obj, .filename, .indent$obj,PACKAGE="RVTK.Base")
    res$.elem <- vtkXMLDataElement(wrapenv(res$.elem))
    res$.indent <- vtkIndent(wrapenv(res$.indent))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ReadElementFromString <- function( .str, .encoding){
    res<-.Call("R_vtkXMLUtilities_ReadElementFromString",.me$obj, .str, .encoding,PACKAGE="RVTK.Base")
    res$ret.val <- vtkXMLDataElement(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$ReadElementFromFile <- function( .filename, .encoding){
    res<-.Call("R_vtkXMLUtilities_ReadElementFromFile",.me$obj, .filename, .encoding,PACKAGE="RVTK.Base")
    res$ret.val <- vtkXMLDataElement(wrapenv(res$ret.val))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$FactorElements <- function( .tree=vtkXMLDataElement()){
    check.VTK(.tree,"vtkXMLDataElement")
    res<-.Call("R_vtkXMLUtilities_FactorElements",.me$obj, .tree$obj,PACKAGE="RVTK.Base")
    res$.tree <- vtkXMLDataElement(wrapenv(res$.tree))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  .me$UnFactorElements <- function( .tree=vtkXMLDataElement()){
    check.VTK(.tree,"vtkXMLDataElement")
    res<-.Call("R_vtkXMLUtilities_UnFactorElements",.me$obj, .tree$obj,PACKAGE="RVTK.Base")
    res$.tree <- vtkXMLDataElement(wrapenv(res$.tree))
    assign(".VTK.Cache",res,.GlobalEnv)
    return(res$ret.val)
  }
 
  if (identical(.me,environment())){
   .me$obj <- .Call("R_vtkXMLUtilities_New")
    reg.finalizer(.me, .me$Delete)
  }
  class(.me) <- c("vtkXMLUtilities",class(.me))
  return(.me)
}
